/*
 *  DBGREAD, {akii-root}/src/dbgread.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#include <stdio.h>
#include "debug.h"

char dbgconst[dbg_last][20] =
{
/*variables.c */
    "getvar",
    "getvarifp",
    "getnumvar",
    "parsedollar",
    "dollar",
    "braces",
    "freevarlist",
    "freenumvarlist",
    "setvar",
    "setnvar",
    "gettoretlen",
    "freeonlist",
    "freetimerlist",
/*expression.c */
    "getoperand",
    "dokif",
    "readkif",
    "readkiffv",
    "readkifop",
    "milyenkifez",
    "readkifinfix",
    "freeinfkif",
    "mkpostfix",
    "freekiffa",
    "mkkiffa",
    "dtos",
    "_valamilyen_op",
/*interpreter.h */
    "freepar",
    "read_timer",
    "read_on",
    "read_return",
    "read_do",
    "read_while",
    "read_else",
    "read_if",
    "read_for",
    "read_foreach",
    "read_alias",
    "read_brkcnt",
    "read_kif",
    "milyenparancs",
    "do_alias",
    "do_if",
    "do_return",
    "do_do",
    "do_while",
    "do_for",
    "do_foreach",
    "do_on",
    "do_timer",
    "dooneparancs",
    "doparancssor",
    "readparancs",
/*commands.c */
    "callfv",
/*regexp.c */
    "regprobal",
    "regszavak",
    "regqszavak",
/*screen.c */
    "parsestatus",
/*main.c */
    "elemez",
    "sendline",
    "szin",
    "lookfortimers",
    "loadakiirc",
/*MODOSITASOK, PLUSSZ: */
    "read_checkpoint",
    "do_checkpoint",
    "KILEPES",
    "SIGNAL"
};

int dbg[dbg_last + 1];
char sdbg[dbg_last][20];
FILE *fp;

main()
{
    int i;

    fp = fopen("akii.dbg", "r");
    if (!fp) {
	fprintf(stderr, "Itt nincs akii.dbg\n");
	exit(1);
    }
    fread(dbg, sizeof(dbg), 1, fp);
    memset(sdbg, 0, sizeof(sdbg));
    if (!feof(fp)) {
	fread(sdbg, sizeof(sdbg), 1, fp);
    }
    fclose(fp);
    fp = fopen("akii.dbg.list", "w+");
    fprintf(fp, "  #: bent:  Aktiv: fuggveny neve:          Egyeb(parameter?):\n");
    for (i = 0; i < dbg_last; i++) {
	if (dbg[i])
	    fprintf(fp, "%3d: %5d", i + 1, dbg[i]);
	else
	    fprintf(fp, "%3d:      ", i + 1);
	fprintf(fp, "       %c %-20s  %s\n", (i == dbg[dbg_last]) ? '*' : ((-i == dbg[dbg_last]) ? '-' : ' '), dbgconst[i], sdbg[i]);
    }
    fprintf(fp, "---<END>--------------------------------------\n\n\n\n\n\n\n\n\n\n\n\n");
    fclose(fp);
    printf("Ok, akii.dbg.list kiirva!\n");
    return (0);
}
